/**
* Filename: EuropeanSportscar.java (in org.openbandy.example)
* This file is part of the BandySerializer project.
*
* www.BandySerializer.org
*/

package org.openbandy.example;

import java.util.Vector;

import org.openbandy.io.Serializable;
import org.openbandy.io.SerializableVector;
import org.openbandy.io.SerializationBuffer;
import org.openbandy.io.Serializer;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class EuropeanSportscar extends Sportscar {

	/* NCAP rating */
	private int ncap = 0;

	
	/* ************ Getter and Setter Methods ************ */
	
	public int getNcap() {
		return ncap;
	}

	public void setNcap(int ncap) {
		this.ncap = ncap;
	}
	
	
	
	/* ************ Methods for interface Serializable ************ */

	public void serialize(Serializer serializer, SerializationBuffer serializationBuffer) {
		serializationBuffer.container().addInt("ncap", ncap);
		
		super.serialize(serializer, serializationBuffer);
	}

	public void deserialize(Serializer serializer, SerializationBuffer serializationBuffer) {
		ncap = serializationBuffer.container().getInt("ncap");

		super.deserialize(serializer, serializationBuffer);
	}

	public void getAttributeNames(Vector attributes) {
		super.getAttributeNames(attributes);
		
		attributes.addElement("ncap");
	}

	public void getReferences(Vector references) {
		super.getReferences(references);
	}

	public void getReferencedIdNames(Vector referencedIdNames) {
		super.getReferencedIdNames(referencedIdNames);
	}

	public String getLegibleString() {
		return super.getLegibleString()+" ncap: "+ncap;
	}

	public boolean isEqualShallow(Serializable serializableObject) throws ClassCastException {
		if(super.isEqualShallow(serializableObject)){
			EuropeanSportscar comparingEuropeanSportscar = (EuropeanSportscar)serializableObject;
			return (this.ncap == comparingEuropeanSportscar.ncap);
		}
		return false;
	}

	public boolean isEqual(Serializable serializableObject) throws ClassCastException {
		if(super.isEqual(serializableObject)){
			return isEqualShallow(serializableObject);
		}
		return false;
	}

	public Serializable getCopy() {
		EuropeanSportscar clone = new EuropeanSportscar();
		/* car attributes */
		clone.carId = this.carId;
		clone.brand = this.brand;
		clone.length = this.length;
		clone.engine = (Engine)this.engine.getCopy();
		clone.tires = (SerializableVector)this.tires.getCopy();
		
		/* sports car attributes */
		clone.bhp = this.bhp;
		clone.sprint = this.sprint;
		
		/* european sports car attributes */
		clone.ncap = this.ncap;
		return clone;
	}

	public Serializable getNewInstance() {
		return new EuropeanSportscar();
	}

}
