/**
* Filename: Sportscar.java (in org.openbandy.example)
* This file is part of the BandySerializer project.
*
* www.BandySerializer.org
*/

package org.openbandy.example;

import java.util.Vector;

import org.openbandy.io.Serializable;
import org.openbandy.io.SerializableVector;
import org.openbandy.io.SerializationBuffer;
import org.openbandy.io.Serializer;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class Sportscar extends Car {
	
	/* breaking horse power */
	protected int bhp = 0;
	
	/* time in secs from 0-60 mph */ 
	protected double sprint = 0.0;

	
	/* ************ Getter and Setter Methods ************ */
	
	public int getBhp() {
		return bhp;
	}

	public void setBhp(int bhp) {
		this.bhp = bhp;
	}

	public double getSprint() {
		return sprint;
	}

	public void setSprint(double sprint) {
		this.sprint = sprint;
	}
	
	
	/* ************ Methods for interface Serializable ************ */

	public void serialize(Serializer serializer, SerializationBuffer serializationBuffer) {
		serializationBuffer.container().addInt("bhp", bhp);
		serializationBuffer.container().addDouble("sprint", sprint);
		
		super.serialize(serializer, serializationBuffer);
	}

	public void deserialize(Serializer serializer, SerializationBuffer serializationBuffer) {
		bhp = serializationBuffer.container().getInt("bhp");
		sprint = serializationBuffer.container().getDouble("sprint");
		
		super.deserialize(serializer, serializationBuffer);
	}

	public void getAttributeNames(Vector attributes) {
		super.getAttributeNames(attributes);
		
		attributes.addElement("bhp");
		attributes.addElement("sprint");
	}

	public void getReferences(Vector references) {
		super.getReferences(references);
	}

	public void getReferencedIdNames(Vector referencedIdNames) {
		super.getReferencedIdNames(referencedIdNames);
	}

	public String getLegibleString() {
		return super.getLegibleString()+" bhp: "+bhp+" sprint time:"+sprint;
	}

	public boolean isEqualShallow(Serializable serializableObject) throws ClassCastException {
		if(super.isEqualShallow(serializableObject)){
			Sportscar comparingSportscar = (Sportscar)serializableObject;
			return ( (this.bhp == comparingSportscar.bhp) &&
					 (this.sprint == comparingSportscar.sprint) );
		}
		return false;
	}

	public boolean isEqual(Serializable serializableObject) throws ClassCastException {
		if(super.isEqual(serializableObject)){
			return isEqualShallow(serializableObject);
		}
		return false;
	}

	public Serializable getCopy() {
		Sportscar clone = new Sportscar();
		/* car attributes */
		clone.carId = this.carId;
		clone.brand = this.brand;
		clone.length = this.length;
		clone.engine = (Engine)this.engine.getCopy();
		clone.tires = (SerializableVector)this.tires.getCopy();
		
		/* sportscar attributes */
		clone.bhp = this.bhp;
		clone.sprint = this.sprint;
		return clone;
	}

	public Serializable getNewInstance() {
		return new Sportscar();
	}
	
}
