/**
 * Filename: PingPongProtocol.java (in org.openbandy.example.pingpong)
 * This file is part of the OpenBandy project.
 *
 * www.openbandy.org
 */

package org.openbandy.example.pingpong;

import org.openbandy.io.Message;
import org.openbandy.net.ServerProtocol;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class PingPongProtocol implements ServerProtocol {

	/**
	 * TODO comment!
	 *
	 * @param sender
	 * @param message
	 * @param serveCounter
	 * @return
	 */
	public Message createMessage(String sender, String message, int serveCounter){
		PingPongMessage pingPongMessage = new PingPongMessage();
		pingPongMessage.setMessageString(message);
		pingPongMessage.setServeCounter(serveCounter);

		Message messageToSend = new Message(sender);
		messageToSend.setContent(pingPongMessage);
		messageToSend.setType(PING_PONG_MESSAGE);
		return messageToSend;
	}

	
	/* *********** Methods for ServerProtocol **************** */
	
	public boolean isValidMessage(Message msg) {
		if(msg != null){
			return ( (msg.getContent() != null) && (isValidType(msg.getType())) );
		}
		return false;
	}
	
    public int getPort(){
    	return PORT_PING_PONG;
    }

	/* *********** Helper Methods **************** */

	private boolean isValidType(int type){
		switch (type) {
		case PING_PONG_MESSAGE : return true;
		default : return false;
		}

	}

}
