/**
* Filename: DirectByteArrayOutputStream.java (in org.openbandy.io.rms)
* This is part of the OpenBandy project.
* 
* www.openbandy.org
*/

package org.openbandy.io.rms;

import java.io.ByteArrayOutputStream;

/**
* A version of ByteArrayOutputStream that gives you
* direct access to the underlying byte array if
* needed.
* 
* (see http://developers.sun.com/techtopics/mobility/midp/articles/databasemapextend/)
*
* <br><br>
* (c) Copyright P. Bolliger 2007, ALL RIGHTS RESERVED.
*
* @author Philipp Bolliger (philipp@bolliger.name)
* @version 1.0
*/
public class DirectByteArrayOutputStream extends ByteArrayOutputStream {

 // Constructs a byte array output stream of default size

 public DirectByteArrayOutputStream(){
     super();
 }

 // Constructs a byte array output stream of given size

 public DirectByteArrayOutputStream( int size ){
     super( size );
 }

 // Returns a reference to the underlying byte array.
 // The actual amount of data in the byte array is
 // obtained via the size method.

 /**
 * TODO comment!
 *
 * @return
 */
public synchronized byte[] getByteArray(){
     return buf;
 }

 // Swaps in a new byte array for the old one, resetting
 // the count as well.

 /**
 * TODO comment!
 *
 * @param newBuf
 * @return
 */
public synchronized byte[] swap( byte[] newBuf ){
     byte[] oldBuf = buf;
     buf = newBuf;
     reset();
     return oldBuf;
 }
}
